<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform">


<xsl:template match="FMEAFurther">
	
								<TABLE id="ContentTable" cellSpacing="0">
									
<xsl:if test="count(Component)>0">

<TR>
		<TD>
			<TABLE id="CutSetTable" cellSpacing="0">
				
<xsl:for-each select="Component">
<TR class="ComponentHeader">
					<TD colspan="5">Component: <xsl:value-of select="Name" /></TD>
					</TR>
<TR class="HeaderRow">
					<TD>Failure Mode</TD>
          <TD>Description</TD>
					<TD>Further Effect</TD>
          <TD>Severity</TD>
					<TD>Contributing Failure Modes</TD>
				</TR>
	<xsl:variable name="component_rowcount">
		<xsl:value-of select="count(CausingEvent/Effect/ContributingCutSet)"/>
	</xsl:variable>
	<xsl:for-each select="CausingEvent">
	<xsl:variable name="pathname"><xsl:value-of select="BasicEventFile" /></xsl:variable>
									
  <xsl:variable name="BE-template" select="document($pathname)"/>
		<xsl:variable name="basic_event_position">
			<xsl:value-of select="position()"/>
		</xsl:variable>
		<xsl:variable name="basic_event_rowcount">
			<xsl:value-of select="count(Effect/ContributingCutSet)"/>
		</xsl:variable>
		<xsl:for-each select="Effect">
			<xsl:variable name="effect_position">
				<xsl:value-of select="position()"/>
			</xsl:variable>
			<xsl:variable name="effect_rowcount">
				<xsl:value-of select="count(ContributingCutSet)"/>
			</xsl:variable>
			<xsl:for-each select="ContributingCutSet">
				<xsl:choose>
					<xsl:when test="$basic_event_position = 1">
						<xsl:choose>
							<xsl:when test="$effect_position = 1">
								<xsl:choose>
									<xsl:when test="position() = 1">
										<xsl:element name="TR"> 
											<xsl:attribute name="class">DataRow</xsl:attribute>

                      <xsl:element name="TD">
                        <xsl:attribute name="rowspan">
                          <xsl:copy-of select="$basic_event_rowcount"/>

                        </xsl:attribute>
                        <xsl:apply-templates select="$BE-template/*" />
                      </xsl:element>

                      <xsl:element name="TD">
                        <xsl:attribute name="rowspan">
                          <xsl:copy-of select="$basic_event_rowcount"/>

                        </xsl:attribute>
                        <xsl:apply-templates select="$BE-template/*/Description" />
                      </xsl:element>
											
											<xsl:element name="TD"> 
											<xsl:attribute name="class"> 
										EffectsCell
									</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													<xsl:copy-of select="$effect_rowcount" />
												</xsl:attribute>
                        <xsl:variable name="name">
                          <xsl:call-template name="string-replace-all">
                            <xsl:with-param name="text" select="../Name" />
                            <xsl:with-param name="replace" select="'::'" />
                            <xsl:with-param name="by" select="'!!'" />
                          </xsl:call-template>
                        </xsl:variable>
												<xsl:element name="a"> 
										<xsl:attribute name="href">
                      javascript:transformIsland('CutSets/XML/<xsl:value-of select="$name" />_CutSets.xml','FTOutput/XSL/cutsetssortOrder.xsl','ContentSpace');
                      transformIsland('CutSets/XML/<xsl:value-of select="$name" />_CutSets.xml','FTOutput/XSL/cutsetstopEvent.xsl','TopEventData');
                      changeTitle('<xsl:value-of select="$name" /> Cut Sets');
                    </xsl:attribute>
                    <xsl:value-of select="../Name" />
                  </xsl:element>
											</xsl:element>
                      <xsl:element name="TD">
                        <xsl:attribute name="class">
                          EffectsCell
                        </xsl:attribute>
                        <xsl:attribute name="rowspan">
                          <xsl:copy-of select="$effect_rowcount" />
                        </xsl:attribute>
                        <xsl:if test="../Severity">
                          <xsl:value-of select="../Severity" />
                        </xsl:if>
                      </xsl:element>
                      
											<xsl:element name="TD"> 
											<xsl:attribute name="class">DataCell</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													1
												</xsl:attribute>
												<xsl:for-each select="ContributingBasicEvent">
											<xsl:variable name="pathname1"><xsl:value-of select="BasicEventFile" /></xsl:variable>
									  <xsl:variable name="BE-template1" select="document($pathname1)"/>
												<xsl:apply-templates select="$BE-template1" />
												</xsl:for-each>
											</xsl:element>
										</xsl:element>	
									</xsl:when>
									<xsl:otherwise>
										<xsl:element name="TR"> 
											<xsl:attribute name="class">DataRow</xsl:attribute>
											<xsl:element name="TD"> 
											<xsl:attribute name="class">DataCell</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													1
												</xsl:attribute>
												<xsl:for-each select="ContributingBasicEvent">
											<xsl:variable name="pathname1"><xsl:value-of select="BasicEventFile" /></xsl:variable>
									  <xsl:variable name="BE-template1" select="document($pathname1)"/>
												<xsl:apply-templates select="$BE-template1" />
												</xsl:for-each>
											</xsl:element>
										</xsl:element>	
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
									<xsl:when test="position() = 1">
										<xsl:element name="TR"> 
											<xsl:attribute name="class">DataRow</xsl:attribute>
											<xsl:element name="TD"> 
											<xsl:attribute name="class"> 
										EffectsCell
									</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													<xsl:copy-of select="$effect_rowcount" />
												</xsl:attribute>
                        <xsl:variable name="name">
                          <xsl:call-template name="string-replace-all">
                            <xsl:with-param name="text" select="../Name" />
                            <xsl:with-param name="replace" select="'::'" />
                            <xsl:with-param name="by" select="'!!'" />
                          </xsl:call-template>
                        </xsl:variable>
												<xsl:element name="a"> 
										<xsl:attribute name="href">
                      javascript:transformIsland('CutSets/XML/<xsl:value-of select="$name" />_CutSets.xml','FTOutput/XSL/cutsetssortOrder.xsl','ContentSpace');
                      transformIsland('CutSets/XML/<xsl:value-of select="$name" />_CutSets.xml','FTOutput/XSL/cutsetstopEvent.xsl','TopEventData');
                      changeTitle('<xsl:value-of select="$name" /> Cut Sets');
                    </xsl:attribute>
                    <xsl:value-of select="../Name" />
                  </xsl:element>
											</xsl:element>
                      <xsl:element name="TD">
                        <xsl:attribute name="class">
                          EffectsCell
                        </xsl:attribute>
                        <xsl:attribute name="rowspan">
                          <xsl:copy-of select="$effect_rowcount" />
                        </xsl:attribute>
                        <xsl:if test="../Severity">
                          <xsl:value-of select="../Severity" />
                        </xsl:if>
                      </xsl:element>
											<xsl:element name="TD"> 
											<xsl:attribute name="class">DataCell</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													1
												</xsl:attribute>
												<xsl:for-each select="ContributingBasicEvent">
												<xsl:variable name="pathname1"><xsl:value-of select="BasicEventFile" /></xsl:variable>
									  <xsl:variable name="BE-template1" select="document($pathname1)"/>
												<xsl:apply-templates select="$BE-template1" />
												</xsl:for-each>
											</xsl:element>
										</xsl:element>	
									</xsl:when>
									<xsl:otherwise>
										<xsl:element name="TR"> 
											<xsl:attribute name="class">DataRow</xsl:attribute>
											<xsl:element name="TD"> 
											<xsl:attribute name="class">DataCell</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													1
												</xsl:attribute>
												<xsl:for-each select="ContributingBasicEvent">
												<xsl:variable name="pathname1"><xsl:value-of select="BasicEventFile" /></xsl:variable>
									  <xsl:variable name="BE-template1" select="document($pathname1)"/>
												<xsl:apply-templates select="$BE-template1" />
												</xsl:for-each>
											</xsl:element>
										</xsl:element>	
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$effect_position = 1">
								<xsl:choose>
									<xsl:when test="position() = 1">
										<xsl:element name="TR"> 
											<xsl:attribute name="class">DataRow</xsl:attribute>
                      <xsl:element name="TD">
                        <xsl:attribute name="rowspan">
                          <xsl:copy-of select="$basic_event_rowcount"/>

                        </xsl:attribute>
                        <xsl:apply-templates select="$BE-template/*" />
                      </xsl:element>

                      <xsl:element name="TD">
                        <xsl:attribute name="rowspan">
                          <xsl:copy-of select="$basic_event_rowcount"/>

                        </xsl:attribute>
                        <xsl:apply-templates select="$BE-template/*/Description" />
                      </xsl:element>
											
											<xsl:element name="TD"> 
											<xsl:attribute name="class"> 
										EffectsCell
									</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													<xsl:copy-of select="$effect_rowcount" />
												</xsl:attribute>
                        <xsl:variable name="name">
                          <xsl:call-template name="string-replace-all">
                            <xsl:with-param name="text" select="../Name" />
                            <xsl:with-param name="replace" select="'::'" />
                            <xsl:with-param name="by" select="'!!'" />
                          </xsl:call-template>
                        </xsl:variable>
												<xsl:element name="a"> 
										<xsl:attribute name="href">
                      javascript:transformIsland('CutSets/XML/<xsl:value-of select="$name" />_CutSets.xml','FTOutput/XSL/cutsetssortOrder.xsl','ContentSpace');
                      transformIsland('CutSets/XML/<xsl:value-of select="$name" />_CutSets.xml','FTOutput/XSL/cutsetstopEvent.xsl','TopEventData');
                      changeTitle('<xsl:value-of select="$name" /> Cut Sets');
                    </xsl:attribute>
                    <xsl:value-of select="../Name" />
                  </xsl:element>
											</xsl:element>
                      <xsl:element name="TD">
                        <xsl:attribute name="class">
                          EffectsCell
                        </xsl:attribute>
                        <xsl:attribute name="rowspan">
                          <xsl:copy-of select="$effect_rowcount" />
                        </xsl:attribute>
                        <xsl:if test="../Severity">
                          <xsl:value-of select="../Severity" />
                        </xsl:if>
                      </xsl:element>
											<xsl:element name="TD"> 
											<xsl:attribute name="class">DataCell</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													1
												</xsl:attribute>
												<xsl:for-each select="ContributingBasicEvent">
												<xsl:variable name="pathname1"><xsl:value-of select="BasicEventFile" /></xsl:variable>
									  <xsl:variable name="BE-template1" select="document($pathname1)"/>
												<xsl:apply-templates select="$BE-template1" />
												</xsl:for-each>
											</xsl:element>
										</xsl:element>
									</xsl:when>
									<xsl:otherwise>
										<xsl:element name="TR"> 
											<xsl:attribute name="class">DataRow</xsl:attribute>
											<xsl:element name="TD"> 
											<xsl:attribute name="class">DataCell</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													1
												</xsl:attribute>
												<xsl:for-each select="ContributingBasicEvent">
												<xsl:variable name="pathname1"><xsl:value-of select="BasicEventFile" /></xsl:variable>
									  <xsl:variable name="BE-template1" select="document($pathname1)"/>
												<xsl:apply-templates select="$BE-template1" />
												</xsl:for-each>
											</xsl:element>
										</xsl:element>	
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:otherwise>
								<xsl:choose>
									<xsl:when test="position() = 1">
										<xsl:element name="TR"> 
											<xsl:attribute name="class">DataRow</xsl:attribute>
											<xsl:element name="TD"> 
											<xsl:attribute name="class"> 
										EffectsCell
									</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													<xsl:copy-of select="$effect_rowcount" />
												</xsl:attribute>
                        <xsl:variable name="name">
                          <xsl:call-template name="string-replace-all">
                            <xsl:with-param name="text" select="../Name" />
                            <xsl:with-param name="replace" select="'::'" />
                            <xsl:with-param name="by" select="'!!'" />
                          </xsl:call-template>
                        </xsl:variable>
												<xsl:element name="a"> 
										<xsl:attribute name="href">
                      javascript:transformIsland('CutSets/XML/<xsl:value-of select="$name" />_CutSets.xml','FTOutput/XSL/cutsetssortOrder.xsl','ContentSpace');
                      transformIsland('CutSets/XML/<xsl:value-of select="$name" />_CutSets.xml','FTOutput/XSL/cutsetstopEvent.xsl','TopEventData');
                      changeTitle('<xsl:value-of select="$name" /> Cut Sets');
                    </xsl:attribute>
                    <xsl:value-of select="../Name" />
                  </xsl:element>
											</xsl:element>
                      <xsl:element name="TD">
                        <xsl:attribute name="class">
                          EffectsCell
                        </xsl:attribute>
                        <xsl:attribute name="rowspan">
                          <xsl:copy-of select="$effect_rowcount" />
                        </xsl:attribute>
                        <xsl:if test="../Severity">
                          <xsl:value-of select="../Severity" />
                        </xsl:if>
                      </xsl:element>
											<xsl:element name="TD"> 
											<xsl:attribute name="class">DataCell</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													1
												</xsl:attribute>
												<xsl:for-each select="ContributingBasicEvent">
												<xsl:variable name="pathname1"><xsl:value-of select="BasicEventFile" /></xsl:variable>
									  <xsl:variable name="BE-template1" select="document($pathname1)"/>
												<xsl:apply-templates select="$BE-template1" />
												</xsl:for-each>
											</xsl:element>
										</xsl:element>	
									</xsl:when>
									<xsl:otherwise>
										<xsl:element name="TR"> 
											<xsl:attribute name="class">DataRow</xsl:attribute>
											<xsl:element name="TD"> 
											<xsl:attribute name="class">DataCell</xsl:attribute>
												<xsl:attribute name="rowspan"> 
													1
												</xsl:attribute>
												<xsl:for-each select="ContributingBasicEvent">
												<xsl:variable name="pathname1"><xsl:value-of select="BasicEventFile" /></xsl:variable>
									  <xsl:variable name="BE-template1" select="document($pathname1)"/>
												<xsl:apply-templates select="$BE-template1" />
												</xsl:for-each>
											</xsl:element>
										</xsl:element>	
									</xsl:otherwise>
								</xsl:choose>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
		</xsl:for-each>
	</xsl:for-each>
</xsl:for-each>
			</TABLE>
		</TD>
	</TR>
</xsl:if>
								</TABLE>

							
</xsl:template>

  <xsl:template match="Description">
    <xsl:choose>
      <xsl:when test="TextBlock">
        <xsl:apply-templates/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>N/A</xsl:text>
      </xsl:otherwise>

    </xsl:choose>


  </xsl:template>

  <xsl:template match="TextBlock">

    <xsl:variable name="string" select="." />
    <xsl:variable name="str-length" select="string-length($string)" />
    <xsl:choose>
      <xsl:when test="$str-length != 0">
        <xsl:value-of select="$string" />
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>N/A</xsl:text>
      </xsl:otherwise>
    </xsl:choose>


  </xsl:template>

  <xsl:template match="LineBreak">
    <br/>
  </xsl:template>
  
  
<xsl:template match="BasicEvent">
 <DIV class="FailureModesCell">
   <xsl:element name="IMG">
     <xsl:attribute name="src">
       FTOutput/images/failureMode.gif
     </xsl:attribute>
   </xsl:element>
   <DIV>
   <xsl:value-of select="Name" />
   </DIV>
 </DIV>
 </xsl:template>
  
<xsl:template match="InputDeviation">
 <DIV class="FailureModesCell">
   <xsl:element name="IMG">
     <xsl:attribute name="src">
       FTOutput/images/InputDeviation.gif
     </xsl:attribute>
    
   </xsl:element> 
   <DIV>
 <xsl:value-of select="Name" />
 </DIV>
 </DIV>
 </xsl:template>

  <xsl:template match="CircleNode">
    <DIV class="FailureModesCell">
      <xsl:element name="IMG">
        <xsl:attribute name="src">
          FTOutput/images/Circle.gif
        </xsl:attribute>

      </xsl:element>
      <DIV>
        <xsl:value-of select="Name" />
      </DIV>
    </DIV>
  </xsl:template>
  <xsl:template name="string-replace-all">
    <xsl:param name="text" />
    <xsl:param name="replace" />
    <xsl:param name="by" />
    <xsl:choose>
      <xsl:when test="contains($text, $replace)">
        <xsl:value-of select="substring-before($text,$replace)" />
        <xsl:value-of select="$by" />
        <xsl:call-template name="string-replace-all">
          <xsl:with-param name="text"
          select="substring-after($text,$replace)" />
          <xsl:with-param name="replace" select="$replace" />
          <xsl:with-param name="by" select="$by" />
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$text" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>

